library nueli.core.bucket;

import 'dart:ui';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

import '../event.dart';

part 'gallery.dart';
part 'glossary.dart';
part 'palette.dart';

abstract class Bucket<T> {
  static Map<Symbol, Map<Symbol, dynamic>> _bucket = {};
  Symbol? _targetID;

  Bucket.configure();

  Symbol get _iD;

  Bucket<T> operator *(Symbol symbol) => this.._targetID = symbol;

  /// Get value
  T operator [](T defaultValue) {
    if (_targetID == null) return defaultValue;
    _bucket.putIfAbsent(_iD, () => {});
    if (!(_bucket[_iD]!).containsKey(_targetID)) return defaultValue;
    return (_bucket[_iD]!)[_targetID] ?? defaultValue;
  }

  /// Set value
  operator []=(T defaultValue, T? value) {
    if (_targetID == null) return;
    _bucket.putIfAbsent(_iD, () => {});
    if ((_bucket[_iD]!).containsKey(_targetID)) defaultValue = (_bucket[_iD] ?? {})[_targetID];
    (_bucket[_iD]!)[_targetID!] = value ?? defaultValue;
  }
}
