part of nueli.core.utils;

extension MapToList on Map<String, String> {
  List<String> toList() {
    List<String> list = map((key, value) => MapEntry(key, '$key 0>$value')).values.toList()..sort();
    return list.map((e) => e.replaceFirst(RegExp('[0-9]+ 0\>'), '')).toList();
  }
}

extension MapToString on Map<String, String> {
  String compile() => json.encode(this);
}

extension ListToMap on List<String> {
  Map<String, String> toMap() {
    return asMap().map((key, value) => MapEntry('$key', value));
  }
}

extension ListToString on List<String> {
  String compile() => toMap().compile();
}

extension StringToMap on String {
  Map<String, String> parseAsMap() {
    try {
      return Map<String, String>.from(json.decode(this) as Map);
    } catch (e) {
      return {};
    }
  }
}

extension StringToList<T> on String {
  List<String> parseAsList() => parseAsMap().toList();
}
